unit G256;

interface

uses dos,q_types;

 type temptype=record
                      tempx,tempy:word;
                      tempdane:obrwsk;
                end;

 var
     LastCardMode  : byte;
     VGAScreen     : byte absolute $A000:0000;

 {procedury podstawowe}
 {--------------------}
 Procedure InitGraph;
 Procedure ClearScreen;
 Procedure CloseGraph;
 function MonitorMono:boolean;
 procedure VGAon;
 procedure VGAoff;
 function ix(var d):word;
 function iy(var d):word;
 procedure putXYin(x,y:word;var dane:obrwsk);

 {procedury do obslugi palety barw}
 {--------------------------------}
 Procedure SetBlack;
 Procedure SetRGB (color : word; red,green,blue : byte);
 Procedure SBP(var Buffor ; FirstColor,Count : word);
 Procedure SBP2(var Buffor ; FirstColor,Count : word);
 Procedure LoadBP(FileName : String; var Where : BPT);
 Procedure GetRGB(color : word; var rec : PaletteRec);
 Procedure GBP(var Where : BlockPaletteType);

 {procedury getputimagowate}
 {-------------------------}

 procedure PutIm(x1,y1:word;var bufor);
 procedure PutImXY(x1,y1,xx,yy,realx:word;var bufor);
 procedure Put4(x1,y1:word;var bufor;kol:byte);
 procedure Put4XY(x1,y1,xx,yy,realx:word;var bufor;kolor:byte);
 procedure Put1XY(x1,y1,xx,yy,realx:word;var bufor;kolor,kolgood:byte);
 procedure Put4XY_1C(x1,y1,xx,yy:word;var bufor;kol,kolgood:byte);
 procedure Put2XY(x1,y1,xx,yy,realx:word;var bufor,bufor2;kolorek:byte);
 Procedure GetImage(x1,y1,Size_X,Size_Y : word; var bufor);
 function  ImageSize(x,y:word):word;
 procedure gettemp(x,y,xx,yy:word;var t:temptype;domem:boolean);
 procedure puttemp(var t:temptype;domem:boolean);

implementation

procedure InitGraph;

begin
 asm
  mov ah,0fh
  int 10h
  mov LastCardMode,al

  mov ah,0
  mov al,19
  int 10h
 end;
 ClearScreen;
end;  { InitGraph }


procedure SetRGB;
var Col : PaletteRec;

begin
 Col.red   := red;
 Col.green := green;
 Col.blue  := blue;
 SBP(Col,Color,1);
end; { SetRGB}

procedure SetBlack;
var jack:bpt;
begin
 fillchar(jack,768,0);
 SBP(jack,0,256);
end;

procedure SBP;
var regs:registers;
begin
    with regs do
      begin
        AX:=$1012;
        BX:=firstcolor;
        CX:=count;
        ES:=Seg(buffor); DX:=Ofs(buffor);
      end;
    Intr($10,regs);
end;

procedure SBP2;
var regs:registers;
begin
 asm
  push	ds
  push	es
  lds   si,buffor
  mov   ax,FirstColor
  mov	dx,3C8h
  out	dx,al
  mov	cx,Count
  mov	dx,3DAh
@1:
  in	al,dx
  test	al,8
  jz	@1
  mov	dx,3C9h

@2:
  lodsb
  out	dx,al
  lodsb
  out	dx,al
  lodsb
  out	dx,al
  loop	@2

  pop	es
  pop	ds
 end;
end; { SBP2 }

procedure LoadBP;
var F   : File;
    Ile : Word;

begin
 Assign(F,FileName);
 {$i-}
 Reset(F,1);
 {$i+}
 if IOResult<>0 then Exit;
 {$i-}
 BlockRead(F,Where,768,Ile);
 {$i+}
 if IOResult<>0 then Exit;
 Close(F);
end; { LoadBP }

procedure GetRGB;
begin
 asm
  mov ax,1015h
  mov bx,color
  int 10h
  push si
  push es
  les si,rec
  mov [si],dh
  mov [si+1],ch
  mov [si+2],cl
  pop es
  pop si
 end;
end;

procedure GBP;

begin
 asm
  mov ax,1017h
  mov bx,0
  mov cx,256
  push es
  les dx,Where
  int 10h
  pop es
 end;
end;

procedure CloseGraph;
begin
 asm
  mov ah,0
  mov al,LastCardMode;
  int 10h
 end;
end; { CloseGraph }

procedure ClearScreen;
begin
 FillChar(VGAscreen,64000,0);
end; { ClearScreen }

function ImageSize(x,y:word):word;
begin
 imagesize:=x*y+10;
end;

procedure GetImage;
var Adres : word;

begin
 Adres:=x1+320*y1;
    Asm
     push ds
     push es
     les di,[bufor]
     mov ax,Size_X
     mov word ptr es:[di],ax
     mov ax,Size_Y
     mov word ptr es:[di+2],ax
     add di,5
     mov bx,Size_x
     mov dx,Size_Y

     mov ax,0A000h
     mov ds,ax
     mov si,adres
     mov cx,dx
@1:  push cx
     mov cx,bx
     push si
     rep movsb
     pop si
     pop cx
     add si,320
     loop @1
     pop es
     pop ds
    end;
end; { GetImage }

function MonitorMono:boolean;
var i:byte;
begin

asm
 mov ax,1A00h
 int 10h
 mov i,bl
end;

case i of
 $7: MonitorMono:=true;
 $8: MonitorMono:=false;
 else begin writeln('BRAK VGA! [',i,']'); halt; end;
end;

end;


procedure VGAon;
begin
 asm
  mov ax,1200h
  mov bl,32h
  int 10h
 end;
end;

procedure VGAoff;
begin
 asm
  mov ax,1201h
  mov bl,32h
  int 10h
 end;
end;

procedure PutIm(x1,y1:word;var bufor);
var Adres : word;
begin
 Adres:=x1+320*y1;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,word ptr ds:[si]
    mov dx,word ptr ds:[si+2]
    add si,5

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx
@1:
    push cx
    mov cx,bx
    push di
    rep movsb
@5:
    pop di
    pop cx
    add di,320
    loop @1
    pop es
    pop ds
    jmp @4

@4:
   end;
end; { PutIm }

procedure PutImXY;
var Adres,reszta : word;
begin
 Adres:=x1+320*y1;
 Reszta:=realx-xx;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,xx           {bx=xx}
    mov dx,yy           {dx=yy}

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx           {cx=dx}
@1:
    push cx             {cx na stos}
    mov cx,bx           {cx=xx}
    push di
    rep movsb
@5:
    pop di
    pop cx              {cx ze stosu}
    add di,320
    add si,reszta
    loop @1
    pop es
    pop ds
    jmp @4

@4:
   end;
end; { PutImXY }

procedure Put4(x1,y1:word;var bufor;kol:byte);
var Adres : word;
begin
 Adres:=x1+320*y1;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,word ptr ds:[si]
    mov dx,word ptr ds:[si+2]
    add si,5

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx
@1:
    push cx
    mov cx,bx
    push di
@2:
    mov ax,[si]
    mov dx,es:[di]
    cmp al,kol
    je  @3
    mov dl,al
    mov es:[di],dx
@3:
    inc di
    inc si
    loop @2
@4:
    pop di
    pop cx
    add di,320
    loop @1
    pop es
    pop ds
   end;
end; { Put4 }

function ix(var d):word;
var w:word;
begin
asm
    push ds
    lds si,[d]
    mov ax,word ptr ds:[si]
    mov w,ax
    pop ds
end;
ix:=w;
end;

function iy(var d):word;
var w:word;
begin
asm
    push ds
    lds si,[d]
    mov ax,word ptr ds:[si+2]
    mov w,ax
    pop ds
end;
iy:=w;
end;

procedure putXYin;
begin
 dane^[1]:=x mod 256;
 dane^[2]:=x div 256;
 dane^[3]:=y;
 dane^[4]:=0;
end;

procedure Put4XY_1C(x1,y1,xx,yy:word;var bufor;kol,kolgood:byte);
var Adres : word;
begin
 Adres:=x1+320*y1;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,word ptr xx
    mov dx,word ptr yy

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx
@1:
    push cx
    mov cx,bx
    push di
@2:
    mov ax,[si]
    mov dx,es:[di]
    cmp al,kol
    je  @3
    mov dl,kolgood
    mov es:[di],dx
@3:
    inc di
    inc si
    loop @2
@4:
    pop di
    pop cx
    add di,320
    loop @1
    pop es
    pop ds
   end;
end; { Put4XY_1C }

procedure Put4XY;
var Adres,reszta : word;
begin
 Adres:=x1+320*y1;
 Reszta:=realx-xx;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,xx           {bx=xx}
    mov dx,yy           {dx=yy}

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx           {cx=dx}
@1:
    push cx             {cx na stos}
    mov cx,bx           {cx=xx}
    push di
@2:
    mov ax,[si]
    mov dx,es:[di]
    cmp al,kolor
    je  @3
    mov dl,al
    mov es:[di],dx
@3:
    inc di
    inc si
    loop @2
@5:
    pop di
    pop cx              {cx ze stosu}
    add di,320
    add si,reszta
    loop @1
    pop es
    pop ds
    jmp @4

@4:
   end;
end; { Put4XY }

procedure Put1XY;
var Adres,reszta : word;
begin
 Adres:=x1+320*y1;
 Reszta:=realx-xx;

   Asm
    push ds
    push es
    lds si,[bufor]
    mov bx,xx           {bx=xx}
    mov dx,yy           {dx=yy}

    mov ax,0A000h
    mov es,ax
    mov di,adres
    mov cx,dx           {cx=dx}
@1:
    push cx             {cx na stos}
    mov cx,bx           {cx=xx}
    push di
@2:
    mov ax,[si]
    mov dx,es:[di]
    cmp al,kolor
    je  @3
    mov dl,kolgood
    mov es:[di],dx
@3:
    inc di
    inc si
    loop @2
@5:
    pop di
    pop cx              {cx ze stosu}
    add di,320
    add si,reszta
    loop @1
    pop es
    pop ds
    jmp @4

@4:
   end;
end; { Put1XY }


procedure gettemp(x,y,xx,yy:word;var t:temptype;domem:boolean);
begin

 with t do
 begin
  if domem then getmem(tempdane,imagesize(xx,yy));
  getimage(x,y,xx,yy,tempdane^);
  tempx:=x;
  tempy:=y;
 end;

end;

procedure puttemp(var t:temptype;domem:boolean);
begin
 with t do
 begin
  putim(tempx,tempy,tempdane^);
  if domem then release(tempdane);
 end;
end;


procedure Put2XY;
type bigarray=array[1..$FFFF] of byte;
var Adres : word;
    axx,ayy:word;

begin
 Adres:=x1+320*y1;
 axx:=realx-xx;

   Asm
    push ds
    push es
    lds si,[bufor]              {DS:SI = bufor}
    mov bx,xx{word ptr ds:[si]  }   {X}
    mov dx,yy{word ptr ds:[si+2]}   {Y}

    les  di,[bufor2]
    mov di,adres
    mov cx,dx
@1:
    push cx
    mov cx,bx
    push di

{    cmp why,0}
    jmp @10

@5:
    pop di
    pop cx
    add di,320
    add si,AXX
    loop @1
    pop es
    pop ds
    jmp @4

@10:
    mov al,byte ptr [si]           {z bufora}
    cmp al,kolorek
    jne  @11
    {jest dziura}
    mov dl,byte ptr es: [di+6]      {z bufora2}
    push es
    push di
    push cx
     mov cx,0A000h
     mov es,cx
     mov al,dl
     stosb
    pop cx
    pop di
    pop es
    jmp @12
@11:
    {al na ekran} {grzejemy normalny obrazek}
    push es
    push di
    push cx
     mov cx,0A000h
     mov es,cx
     stosb
    pop cx
    pop di
    pop es
@12:

    inc di
    inc si
    loop @10
    jmp @5

@4:
   end;
end; { PutImage2XY}


end.
