unit q_uhf;

{uzywanie fontow typu UHF, kazdy font opisuja wartosci:
 zmodyfikowane}

interface

uses dos,q_types,g256;
type
        uhf_char_type=record x,y,ydown:byte;
                      end;
        uhf_tab=array[0..255] of ^uhf_char_type;

        UHF_type=record
                    font:obrwsk;
                    spacja,odstep:byte;
                    wsk:array[0..255] of word;
                    tablica:uhf_tab;
                 end;
        uhf_set=set of byte;

var              fsys:uhf_type;

{------------------------------------------------------------------------}
PROCEDURE LOAD_UHF (name:string; var foncik:uhf_type);
{laduje fonta do pamieci/przydziela pamiec!}
{------------------------------------------------------------------------}
PROCEDURE WRITE_UHF(x1,y1,kolor:word;s:string;var foncik:uhf_type);
{pisze tekst na ekranie x,y w kolorze kolor}
{------------------------------------------------------------------------}
PROCEDURE WRITE_UHF_FULL(x1,y1:word;s:string;var foncik:uhf_type;k:integer);
{------------------------------------------------------------------------}
PROCEDURE
 MAKE_UHF(s:string;var dane:obrwsk;var foncik:uhf_type;k,x1,x2,y1,y2:word);
{------------------------------------------------------------------------}
PROCEDURE MAKE_UHF_FULL(s:string;var dane:obrwsk;var foncik:uhf_type;
  xx,yy,y1:word); {robi w kolorach oryg.w pudle xx/yy o y1 w dol}
{------------------------------------------------------------------------}
FUNCTION ixUHF(s:string;foncik:uhf_type):word;
FUNCTION iyUHF(s:string;foncik:uhf_type):byte;

implementation

PROCEDURE LOAD_UHF;
var s:s20;
    napisik : obrwsk;
    plik : file;
    i,index,a: word;
    ile,bajt:byte;
    zx:searchrec;

begin

  for a:=0 to 255 do
   foncik.wsk[a]:=0;

  with foncik do
  BEGIN

   spacja:=4;
   odstep:=1;

   doserror:=0;
   if pos('.',name)=0 then name:=name+'.UHF';
   findfirst(name,anyfile,zx);
   Assign(plik,name);
   Reset(plik,1);
   if ioresult+doserror<>0 then haltix(name);
   blockread(plik,s[1],10);
   s[0]:=#7;
   if s<>'UHOFONT' then haltix(name+' to nie UHF');
   ile:=ord(s[10]);
   getmem(font,zx.size-10-4*ile+20);
   index:=1;
   FOR A:=1 to ILE do
   BEGIN
    blockread(plik,bajt,1);
    new(tablica[bajt]);
    blockread(plik,tablica[bajt]^.Ydown,1);
    blockread(plik,tablica[bajt]^.x,1);
    blockread(plik,tablica[bajt]^.y,1);
    i:=tablica[bajt]^.x*tablica[bajt]^.y;
    blockread(plik,font^[index],i);
    wsk[bajt]:=index;
    inc(index,i);
   END;
  END; {with}
end;

PROCEDURE WRITE_UHF(x1,y1,kolor:word;s:string;var foncik:uhf_type);
var a,b,c,d,e:word;
begin

 for a:=1 to length(s) do
 with foncik do
 begin
  c:=ord(s[a]);
  if c=32 then inc(x1,spacja) else
  if wsk[c]<0 then else
  BEGIN
   put4xy_1C(x1,y1+tablica[c]^.ydown,tablica[c]^.x,tablica[c]^.y,
          font^[wsk[c]],0,kolor);
   inc(x1,odstep+tablica[c]^.x);
  END;
 end;

end;

PROCEDURE WRITE_UHF_FULL;
var a,b,c,d,e:word;
begin

 for a:=1 to length(s) do
 with foncik do
 begin
  c:=ord(s[a]);
  if c=32 then inc(x1,spacja) else
  if wsk[c]>0 then
  BEGIN
   if k<0 then
   putImXY(x1,y1+tablica[c]^.ydown,tablica[c]^.x,tablica[c]^.y,
           tablica[c]^.x,font^[wsk[c]]) else
   put4XY (x1,y1+tablica[c]^.ydown,tablica[c]^.x,tablica[c]^.y,
           tablica[c]^.x,font^[wsk[c]],0);
   inc(x1,odstep+tablica[c]^.x);
  END;
 end;

end;


PROCEDURE MAKE_UHF;
var a,b,c,d,z,cx,cy,cc,xx,yy:word;
begin

 xx:=ixUHF(s,foncik)+x1+x2;
 yy:=iyUHF(s,foncik)+y1+y2;
 putXYin(xx,yy,dane);
 fillchar(dane^[6],xx*yy,0);
 for a:=1 to length(s) do
 with foncik do
 begin
  z:=ord(s[a]);
  if z=32 then inc(x1,spacja) else
  if wsk[z]>0 then
  BEGIN
   d:=6+x1+xx*(y1+tablica[z]^.ydown);
   cx:=tablica[z]^.x-1;
   cy:=tablica[z]^.y-1;
   cc:=wsk[z];
   for b:=0 to cy do
    for c:=0 to cx do
    begin
     if k=0 then dane^[d+c+b*xx]:=font^[cc] else
     if font^[cc]<>0 then dane^[d+c+b*xx]:=k;
     inc(cc);
    end;
   inc(x1,odstep+tablica[z]^.x);
  END;
 end;
end;
{------------------------------------------------------}
PROCEDURE MAKE_UHF_FULL;
var a,b,c,d,z,cx,cy,cc,x1:word;
begin

 x1:=ixUHF(s,foncik); if x1>=xx then exit;
 x1:=xx div 2-x1 div 2;
 putXYin(xx,yy,dane);
 fillchar(dane^[6],xx*yy,0);

 for a:=1 to length(s) do
 with foncik do
 begin
  z:=ord(s[a]);
  if z=32 then inc(x1,spacja) else
  if wsk[z]>0 then
  BEGIN
   d:=6+x1+xx*(y1+tablica[z]^.ydown);
   cx:=tablica[z]^.x;
   cy:=tablica[z]^.y;
   cc:=wsk[z];
   for b:=0 to cy-1 do
    move(font^[cc+b*cx],dane^[d+b*xx],cx);
   inc(x1,odstep+cx);
  END;
 end;
end;

{------------------------------------------------------}
FUNCTION ixUHF(s:string;foncik:uhf_type):word;
var x:word;
    a:byte;
begin

 x:=(length(s)-1)*foncik.odstep;
 for a:=1 to length(s) do
  if s[a]=' ' then inc(x,foncik.spacja-foncik.odstep) else
  if foncik.wsk[ord(s[a])]>0 then
   inc(x,foncik.tablica[ord(s[a])]^.x);

 ixUHF:=x;

end;

FUNCTION iyUHF(s:string;foncik:uhf_type):byte;
var a,b,y:byte;
begin

 y:=0;
 for a:=1 to length(s) do
 begin
  if foncik.wsk[ord(s[a])]=0 then else
  begin
   b:=foncik.tablica[ord(s[a])]^.ydown+foncik.tablica[ord(s[a])]^.y;
   if (s[a]<>' ') and (b>y) then y:=b; end;
 end;
 iyUHF:=y;

end;

end.
